#include <bits/stdc++.h>

#define MAXN 1024
#define MAX_NUM 2048
#define endl '\n'

using namespace std;

int n, m;
int table[MAXN][MAXN];
bool visited[MAX_NUM];
tuple<int, int, int, int, int> rects[MAXN];

unordered_map<int, int> codeColor;
int currCode = 0;

int code(int x) {
    if (codeColor.find(x) != codeColor.end()) return codeColor[x];
    return codeColor[x] = ++currCode;
}

int pattern[MAXN][MAXN];

void Draw(int idx) {
    int x, up, le, dw, ri;
    tie(x, up, le, dw, ri) = rects[idx];

    for (int i = up; i <= dw; i++) {
        for (int j = le; j <= ri; j++) {
            pattern[i][j] = x;
        }
    }
}

bool check() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (pattern[i][j] != table[i][j]) return false;
        }
    }

    return true;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> table[i][j];
            visited[table[i][j]] = true;
        }
    }

    int k = 0;
    vector<int> colors;

    for (int i = 1; i < MAX_NUM; i++) {
        if (visited[i]) {
            k++;
            colors.push_back(i);
        }
    }

    for (int x : colors) {
        int up;

        for (int i = 1; i <= n; i++) {
            bool found = false;

            for (int j = 1; j <= n; j++) {
                if (table[i][j] == x) {
                    up = i;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int le;

        for (int j = 1; j <= n; j++) {
            bool found = false;

            for (int i = 1; i <= n; i++) {
                if (table[i][j] == x) {
                    le = j;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int dw;

        for (int i = n; i >= 1; i--) {
            bool found = false;

            for (int j = 1; j <= n; j++) {
                if (table[i][j] == x) {
                    dw = i;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int ri;

        for (int j = n; j >= 1; j--) {
            bool found = false;

            for (int i = 1; i <= n; i++) {
                if (table[i][j] == x) {
                    ri = j;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        rects[code(x)] = {x, up, le, dw, ri};
    }

    int perm[10];

    for (int i = 1; i <= k; i++) perm[i] = i;

    do {
        for (int i = 1; i <= k; i++) Draw(perm[i]);

        if (check()) {
            cout << k << endl;
            for (int i = 1; i <= k; i++) {
                int x, up, le, dw, ri; tie(x, up, le, dw, ri) = rects[perm[i]];
                cout << x << " " << up << " " << le << " " << dw << " " << ri << endl;
            }

            break;
        }

    } while (next_permutation(perm + 1, perm + k + 1));

    return 0;
}
