#include <bits/stdc++.h>

#define MAXN 1024
#define MAX_NUM 2048
#define endl '\n'

using namespace std;

int n, m;
int table[MAXN][MAXN];
bool visited[MAX_NUM];
tuple<int, int, int, int, int> rects[MAX_NUM];

bool intersect(int i, int j) {
    int a, x1, y1, x2, y2; tie(a, x1, y1, x2, y2) = rects[i];
    int b, x3, y3, x4, y4; tie(b, x3, y3, x4, y4) = rects[j];

    return (y1 <= y4 && y2 >= y3) && (x1 <= x4 && x2 >= x3);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> table[i][j];
            visited[table[i][j]] = true;
        }
    }

    int k = 0;
    vector<int> colors;

    for (int i = 1; i < MAX_NUM; i++) {
        if (visited[i]) {
            k++;
            colors.push_back(i);
        }
    }

    for (int x : colors) {
        int up;

        for (int i = 1; i <= n; i++) {
            bool found = false;

            for (int j = 1; j <= n; j++) {
                if (table[i][j] == x) {
                    up = i;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int le;

        for (int j = 1; j <= n; j++) {
            bool found = false;

            for (int i = 1; i <= n; i++) {
                if (table[i][j] == x) {
                    le = j;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int dw;

        for (int i = n; i >= 1; i--) {
            bool found = false;

            for (int j = 1; j <= n; j++) {
                if (table[i][j] == x) {
                    dw = i;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int ri;

        for (int j = n; j >= 1; j--) {
            bool found = false;

            for (int i = 1; i <= n; i++) {
                if (table[i][j] == x) {
                    ri = j;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        rects[x] = {x, up, le, dw, ri};
    }

    vector<pair<int, int>> order;

    for (int i = 0; i < colors.size(); i++) {
        int curr = 0;

        for (int j = 0; j < colors.size(); j++) {
            if (i == j) continue;
            if (intersect(colors[i], colors[j])) curr++;
        }

        order.push_back({curr, colors[i]});
    }

    sort(order.begin(), order.end());

    cout << k << endl;

    for (int i = order.size() - 1; i>= 0; i--) {
        int x, up, le, dw, ri; tie(x, up, le, dw, ri) = rects[order[i].second];
        cout << x << " " << up << " " << le << " " << dw << " " << ri << endl;
    }

    return 0;
}
