#include <bits/stdc++.h>

#define MAXN 65

using namespace std;

string toBinary(long long number) {
    string bin;

    while (number != 0) {
        bin.push_back(char(number % 2 + '0'));
        number = number / 2;
    }

    reverse(bin.begin(), bin.end());

    return bin;
}

long long pascal[MAXN][MAXN];

void InitBinom() {
    pascal[0][0] = 1;

    for (int i = 1; i <= 64; i++) {
        pascal[i][0] = 1;
        for (int j = 1; j <= i; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }
}

long long binomCoeficient(int a, int b) {
    return pascal[a][b];
}

long long dp[MAXN][MAXN][2];

long long f(const string& x, int n, int s, bool l) {
    if (s < 0) return 0;
    if (n == 0 && s == 0) return 1;
    if (n == 0 && s != 0) return 0;
    if (dp[n][s][l] != -1) return dp[n][s][l];

    long long ans = 0;

    for (int d = 0; d <= 1; d++) {
        if (!l) {
            if (d == 0) ans += f(x, n - 1, s - 1, false);
            if (d == 1) ans += f(x, n - 1, s, false);
        } else {
            if (d < (x[x.size() - n] - '0')) ans += f(x, n - 1, s - 1, false);

            if (d == (x[x.size() - n] - '0')) {
                if (d == 0) ans += f(x, n - 1, s - 1, true);
                if (d == 1) ans += f(x, n - 1, s, true);
            }
        }
    }

    return dp[n][s][l] = ans;
}

void Init() {
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            for (int k = 0; k < 2; k++) {
                dp[i][j][k] = -1;
            }
        }
    }
}

long long calculate(const string& maxNumber, int k) {
    if (maxNumber == "0") return 0;

    int n = maxNumber.size();
    long long ans = 0;

    for (int i = k + 1; i < n; i++) {
        ans += binomCoeficient(i - 1, k);
    }

    string newBound = maxNumber; newBound.erase(0, 1);

    Init();

    return ans + f(newBound, newBound.size(), k, true);
}

int main() {
    long long l, r; cin >> l >> r;
    int k; cin >> k;

    if (l > r) swap(l, r);

    string sr = toBinary(r);
    string sl = toBinary(l - 1);

    InitBinom();

    //cout << calculate(sr, k) << " " << calculate(sl, k) << endl;

    cout << calculate(sr, k) - calculate(sl, k) << endl;

    return 0;
}
