#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int grid[1005][1005];
int Left[2005];
int Right[2005];
int up[2005];
int down[2005];

bool erased[2005];
set <int> drawn;
bool canErase(int k)
{
    int i, j;
    for (i = up[k]; i <= down[k]; i++)
    {
        for (j = Left[k]; j <= Right[k]; j++)
        {
            if (grid[i][j] != k && grid[i][j] != -1)
                return false;
        }
    }

    return true;
}

void Erase(int k)
{
    int i, j;
    for (i = up[k]; i <= down[k]; i++)
    {
        for (j = Left[k]; j <= Right[k]; j++)
        {
            grid[i][j] = -1;
        }
    }
}

struct Rectangle
{
    int num, up, Left, down, Right;
    Rectangle(){}
    Rectangle(int num, int up, int Left, int down, int Right)
    {
        this->num = num;
        this->up = up;
        this->Left = Left;
        this->down = down;
        this->Right = Right;
    }
};

void Print(int n, int m)
{
    int i, j;
    cout << "********************" << endl;
    for (i = 1; i <= n; i++)
    {
        for (j = 1; j <= m; j++)
        {
            cout << grid[i][j] << " ";
        }
        cout << endl;
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m, k;
    cin >> n >> m;

    for (int i = 0; i < 2005; i++)
        up[i] = Left[i] = 2000;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            cin >> k;
            grid[i][j] = k;

            if (k > 0)
            {
                Left[k] = min(Left[k], j);
                up[k] = min(up[k], i);
                Right[k] = max(Right[k], j);
                down[k] = max(down[k], i);
                drawn.insert(k);
            }
        }
    }

    vector <Rectangle> answer;
    int total = drawn.size();
    while (total)
    {
        for (int curr:drawn)
        {
            if (erased[curr] == false)
            {
                if (canErase(curr))
                {
                    Erase(curr);
                    Rectangle currRectangle = Rectangle(curr, up[curr], Left[curr], down[curr], Right[curr]);
                    answer.emplace_back(currRectangle);
                    erased[curr] = true;
                    total--;
                }
            }

        }
        if (total < 0)
            break;

    }

    cout << answer.size() << endl;
    for (int i = answer.size()-1; i >= 0; i--)
    {
        cout << answer[i].num << " " << answer[i].up << " " << answer[i].Left
        << " " << answer[i].down << " " << answer[i].Right << endl;
    }

    return 0;
}
