#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const int maxn = 1024;
int n, m, k, a[maxn][maxn], br[3 * maxn], used[maxn][maxn];
vector<int> v[2 * maxn], p;

struct cell{
    int x, y;

    bool inRange(){
        return x > 0 && x <= n && y > 0 && y <= m;
    }
    cell operator+(cell c){
        return {x + c.x, y + c.y};
    }

    bool operator==(cell c){
        return x == c.x && y == c.y;
    }
    bool operator!=(cell c){
        return x != c.x || y != c.y;
    }
};

cell ml[maxn], mr[maxn], mil[maxn], mir[maxn], dir[4] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= m;j++){
            cin >> a[i][j];
        }
    }
}

void BFS(cell c, int idx){
    queue<cell> q;
    used[c.x][c.y] = 1;
    ml[idx] = mr[idx] = mil[idx] = mir[idx] = c;
    q.push(c);
    while(!q.empty()){
        cell t = q.front(); q.pop();
        for(int i = 0;i < 4;i++){
            cell curr = t + dir[i];
            if(curr.inRange()){
                if(!used[curr.x][curr.y] && a[curr.x][curr.y] == a[c.x][c.y]){
                    q.push(curr);
                    used[curr.x][curr.y] = 1;
                    if(curr.x <= ml[idx].x && curr.y <= ml[idx].y) ml[idx] = curr;
                    if(curr.x <= mil[idx].x && curr.y >= mil[idx].y) mil[idx] = curr;
                    if(curr.x >= mr[idx].x && curr.y <= mr[idx].y) mr[idx] = curr;
                    if(curr.x >= mir[idx].x && curr.y >= mir[idx].y) mir[idx] = curr;
                }
            }
        }
    }
}

void preCompute(){
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= m;j++){
            if(a[i][j] != 0 && !used[i][j]){
                BFS({i, j}, a[i][j]);
                p.push_back(a[i][j]);
            }
        }
    }
    int len = p.size();
    cout << len << endl;
    for(int i = 0;i < len;i++){
        cout << p[i] << " " << mir[p[i]].x << " " << mir[p[i]].y << " ";
        cout << ml[p[i]].x << " " << ml[p[i]].y << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
    read();
    preCompute();
	return 0;
}
